; ---------------------------------------------------------
;	timing checker										
; =========================================================
;	2007/01/19	t.hara									
; ---------------------------------------------------------

	.area	_CODE

bdos		= 0x0005
calslt		= 0x001c
keyint		= 0x0038
chgmod		= 0x005f

r0sav		= 0xf3df
scrmod		= 0xfcaf
extslt		= 0xfcc0

vdp_port0	= 0x98
vdp_port1	= 0x99
vdp_port2	= 0x9a
vdp_port3	= 0x9b

oldkey		= 0xfbda
newkey		= 0xfbe5

; ---------------------------------------------------------
;	main()
; ---------------------------------------------------------
_main::
	call	initialize
	call	main_loop
	call	terminate
	ret

; ---------------------------------------------------------
;	initialize()
;	
; ---------------------------------------------------------
initialize:
	;	݂̃XN[[hԍۑ
	ld		a, (scrmod)
	ld		(backup_scr_mode), a
	;	screen5 ɕύX
	ld		a, #5
	ld		ix, #chgmod
	ld		iy, (extslt)
	call	calslt
	;	ʂ palette 0 œhԂ
	call	fill_pal1
	;	荞݃tbN
	call	initialize_intr
	ret

backup_scr_mode:
	.db		0

; ---------------------------------------------------------
;	terminate()
;	n
; ---------------------------------------------------------
terminate:
	;	荞݃tbN
	call	terminate_intr
	;	XN[[hɖ߂
	ld		a, (backup_scr_mode)
	ld		ix, #chgmod
	ld		iy, (extslt)
	call	0x001c
	;	JEgl𕶎ɕϊ
	ld		de, (loop_count)
	ld		b, #0

	ld		a, d
	rra
	rra
	rra
	rra
	and		#0x0f
	ld		c, a
	ld		hl, #hex_number
	add		hl, bc
	ld		a, (hl)
	ld		(output_hex_number+0), a

	ld		a, d
	and		#0x0f
	ld		c, a
	ld		hl, #hex_number
	add		hl, bc
	ld		a, (hl)
	ld		(output_hex_number+1), a

	ld		a, e
	rra
	rra
	rra
	rra
	and		#0x0f
	ld		c, a
	ld		hl, #hex_number
	add		hl, bc
	ld		a, (hl)
	ld		(output_hex_number+2), a

	ld		a, e
	and		#0x0f
	ld		c, a
	ld		hl, #hex_number
	add		hl, bc
	ld		a, (hl)
	ld		(output_hex_number+3), a

	;	o͂
	ld		c, #0x09
	ld		de, #output_string
	call	bdos
	ret

hex_number:
	.ascii	"0123456789ABCDEF"
output_string:
	.ascii	"LAST LOOP COUNT = "
output_hex_number:
	.ascii	"####"
	.db		10, 13, 0x24

; ---------------------------------------------------------
;	fill_pal1()
;	ʂpbg 1 Ŗߐs
; ---------------------------------------------------------
fill_pal1:
	ld		c, #vdp_port1
	di
	;	VDPI[gCNg WX^Cg
	ld		a, #36				;	R#36珑ݎn߂
	out		(c), a
	ld		a, #17+0x80
	out		(c), a

	ld		c, #vdp_port3
	xor		a
	ld		b, a

	out		(c), a				;	DX
	out		(c), a
	out		(c), a				;	DY
	out		(c), a
	inc		a
	out		(c), b				;	NX
	out		(c), a
	out		(c), b				;	NY
	out		(c), a
	ld		a, #0x11
	out		(c), a				;	CLR
	out		(c), b				;	MXD,DIY,DIX
	ld		a, #0xC0
	out		(c), a				;	HMMV
wait_vdp_complete:
	ld		a, #2
	call	get_vdp_status
	and		#0x01
	jr		nz, wait_vdp_complete
	xor		a
	call	get_vdp_status
	ei
	ret

; ---------------------------------------------------------
;	initialize_intr()
;	荞ݏɃtbN
;	v̂߂ H.KEYI ł͂Ȃ]vȏȂ悤
;	KEYINT  (蒆́Ȁ{Ȃ)
; ---------------------------------------------------------
initialize_intr:
	;	keyint obNAbv
	ld		hl, #keyint
	ld		de, #backup_keyint
	ld		bc, #3
	ldir
	;	V荞ݏݒ肷
	di
	ld		a, #0xc3				;	jp intr_handler
	ld		(keyint), a
	ld		hl, #intr_handler
	ld		(keyint+1), hl
	;	荞݂ݒ肷
	ld		a, #43					;	line #43
	call	set_hsync_line
	ei
	ret

backup_keyint:
	.ds		3

; ---------------------------------------------------------
;	terminate_intr()
;	荞ݏ̃tbN
; ---------------------------------------------------------
terminate_intr:
	di
	ld		hl, #backup_keyint
	ld		de, #keyint
	ld		bc, #3
	ldir
	ei
	ret

; ---------------------------------------------------------
;	main_loop()
;	C[v
; ---------------------------------------------------------
main_loop:
	;	͔
	ld		a, (newkey+7)
	and		#0x04			;	ESCL[ (ꂽL[̃rbg 0 ɂȂ)
	jp		z, main_exit

	ld		a, (newkey+8)
	ld		c, a
	and		#0x40			;	L[
	jp		z, down_key
	ld		a, c
	and		#0x20			;	L[
	jp		z, up_key
	jp		main_loop
main_exit:
	ret

down_key:
	ld		hl, (loop_count)
	ld		a, l
	or		h
	jp		z, key_release_wait
	dec		hl
	ld		(loop_count), hl
	ld		c, #0x40
	jp		key_release_wait

up_key:
	ld		hl, (loop_count)
	inc		hl
	ld		(loop_count), hl
	ld		c, #0x20
	jp		key_release_wait

key_release_wait:
	ld		b, #30
check_refresh_wait:
	nop
	djnz	check_refresh_wait
	ld		a, (newkey+8)
	and		c
	jp		z, key_release_wait
	jp		main_loop

loop_count::
	.dw		0x230			;	󃋁[vJEg

; ---------------------------------------------------------
;	update_keymat()
;	荞݂Ă܂ BIOS ̃L[}gNX
;	XVpȂȂ̂ŁAs
; ---------------------------------------------------------
update_keymat:
	;	PÕL[Ԃۑ
	ld		hl, #newkey
	ld		de, #oldkey
	ld		bc, #11
	ldir
	;	VL[ԂɍXV
	in		a, (0xaa)
	and		#0xf0
	ld		c, a
	ld		b, #11
	ld		hl, #newkey
keymat_loop:
	ld		a, c
	out		(0xaa), a
	in		a, (0xa9)
	ld		(hl), a
	inc		c
	inc		hl
	djnz	keymat_loop
	ret

; ---------------------------------------------------------
;	get_vdp_status( A )
;	VDP ̃Xe[^XWX^ǂݍ
;	in
;		A = Xe[^XWX^ԍ
;	out:
;		A = Xe[^XWX^̒l
;	break:
;		C
;	comment:
;		ւŌĂԂ
; ---------------------------------------------------------
get_vdp_status:
	ld		c, #vdp_port1
	out		(c), a
	ld		a, #15+0x80
	out		(c), a
	in		a, (c)
	ret

; ---------------------------------------------------------
;	set_palette( A, HL )
;	VDP ̃J[pbgݒ肷
;	in:
;		A = pbgԍ
;		HL = 0x0GRB			(G, R, B ͂ꂼ 0`7)
;	break:
;		C
;	comment:
;		ւŌĂԂ
; ---------------------------------------------------------
set_palette:
	ld		c, #vdp_port1
	out		(c), a
	ld		a, #16+0x80
	out		(c), a
	ld		c, #vdp_port2
	out		(c), l
	out		(c), h
	ret

; ---------------------------------------------------------
;	set_hsync_line( A )
;	荞ݔCԍw肷
;	in:
;		A = Cԍ
;	break:
;		C
;	comment:
;		ւŌĂԂ
; ---------------------------------------------------------
set_hsync_line:
	;	R#19 ɃCԍw
	ld		c, #vdp_port1
	out		(c), a
	ld		a, #19+0x80
	out		(c), a
	;	荞݋
	ld		a, (r0sav)
	or		a, #0x10
	out		(c), a
	ld		a, #0+0x80
	out		(c), a
	ret

; ---------------------------------------------------------
;	vsync_handler()
;	荞 (1/60b)
; ---------------------------------------------------------
vsync_handler:
	;	L[}gNXXV
	call	update_keymat
	;	pbg#1 ΂ɂ
	ld		a, #1
	ld		hl, #0x0700
	call	set_palette
	;	w񐔂ׂ̕|
	ld		bc, (loop_count)
stress_loop:
	ld		a, c
	or		b
	ret		z
	dec		bc
	jp		stress_loop

; ---------------------------------------------------------
;	hsync_handler()
;	荞
; ---------------------------------------------------------
hsync_handler:
	;	pbg#1 ɂ
	ld		a, #1
	ld		hl, #0x0770
	call	set_palette
	ret

; ---------------------------------------------------------
;	intr_handler()
;	荞ݏnh
; ---------------------------------------------------------
intr_handler:
	;	WX^ۑ
	push	af
	push	hl
	push	de
	push	bc
	;	荞ݗv𔻒f
check_vsync:
	xor		a						;	a = get_vdp_status( S#0 )
	call	get_vdp_status			;	ǂݏo S#0  bit7 ̓NAAVDP̊荞ݏԂ͉
	and		#0x80
	jp		z, check_hsync
	call	vsync_handler
	jp		intr_exit
check_hsync:
	inc		a						;	a = get_vdp_status( S#1 )
	call	get_vdp_status			;	ǂݏo S#1  bit0 ̓NAAVDP̊荞ݏԂ͉
	and		#0x01
	call	nz, hsync_handler
	;	WX^A
intr_exit:
	pop		bc
	pop		de
	pop		hl
	pop		af
	ei
	reti
intr_handler_end:
